<html>
<head>
  <title>Shamir Sır Paylaşım Şeması</title>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <meta name="viewport" content="width=device-width, initial-scale=1">

  <script type="text/javascript" src="jquery-1.10.2.js"></script>
  <!--<link rel="stylesheet" type="text/css" href="bootstrap-3.3.7-dist/css/bootstrap.css">
  <script type="text/javascript" src="bootstrap-3.3.7-dist/js/bootstrap.js"></script>-->

  <script type="text/javascript" src="calculationlib/matrixlib.js"></script>
  <script type="text/javascript" src="calculationlib/ecclib.js"></script>
  <script type="text/javascript" src="calculationlib/polynomial.js"></script>
  <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.6/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
  <!--<script type="text/javascript" src="MathJax/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>-->
  <script type="text/x-mathjax-config">
    MathJax.Hub.Config({tex2jax: {inlineMath: [['$','$'], ['\\(','\\)']]}});
    MathJax.Localization.setLocale("tr");
  </script>
  <script>
    var WriteFormula = function(divId, TeX) {
  		var selector = "#" + divId;
  		var selObj = $(selector)
  		if(selObj.length > 0){
  			var queue = MathJax.Hub.queue;
  			var math = MathJax.Hub.getAllJax(divId)[0];
  			queue.Push(
  				function () { selObj.css('visibility','hidden') },
  				//["resetEquationNumbers",MathJax.InputJax.TeX],
  				["Text",math,"\\displaystyle{"+TeX+"}"],
  				function () { selObj.css('visibility','visible') }
  			);
  		}
    }
    var AddFormula = function(container, name, tex) {
  		var containerSelector = $('#' + container);
  		if ($('#' + name).length == 0)
  			containerSelector.append("<div id='" + name + "' style='text-align:center; visibility: visible; padding:10;'>");
  		else $('#' + name).html("");

  		$('#' + name).append($('<script type="math/tex">').text("\\displaystyle{"+tex+"}"));
  		MathJax.Hub.Queue(
  			function () { $('#' + name).css('visibility','hidden') },
  			["Typeset",MathJax.Hub],
  			function () { $('#' + name).css('visibility','visible') }
  		);
    }
	var CreateInput = function(inputCount, q) {
		var text = "<table>"
		text += "<tr>";
		for (var i = 1; i < inputCount+1; i++)
			text += "<td align='center'>" + i + "</td>";
		text += "</tr>";
		text += "<tr>";
		for (var i = 1; i < inputCount+1; i++)
			text += "<td><input type='text' style='text-align:center;' maxlength='4' size='4' num=" + i + " id='txtInpt" + i + "' /></td>";
		text += "</tr>";
		text += "</table>";
		return text;
  }
  </script>
</head>

<body>

  <h2>Shamir Sır Paylaşım Şeması </h2>

  <h3>Sırı Oluşturma</h2>
  <div id="divConstSecretParams">
    <table>
      <tr>
        <td>  <strong>q</strong>  </td>
        <td>  <input type="text" id="txtQ" value="17"/> $1 \lt K \lt N \lt q$ </td>
      </tr>
      <tr>
        <td>  <strong>K</strong>  </td>
        <td>  <input type="text" id="txtK" value="6"/>  </td>
      </tr>
      <tr>
        <td>  <strong>N</strong>  </td>
        <td>  <input type="text" id="txtN" value="10"/>  </td>
      </tr>
      <tr>
        <td>  <strong>Sır</strong>  </td>
        <td>  <input type="text" id="txtSecret" value="3"/> $ s \in F_{q} $ </td>
      </tr>
      <tr>
        <td> </div>
        <td>  <input type="button" id="btnConstructSecret" value="Sırrı Oluştur" />  </td>
      </tr>
	</table>
  </div>
  <div id="divConstSecretResult"></div>

  <h3>Sırrı Çözme</h3>
  <div id="divFindSecretParams">
    <b>q:</b> <input type='text' id='txtQ2' value='17'/> <br />
    <div id="divSecretInputs"></div>
    <input type='button' id='btnFindSecret' value='Sırrı Bul' />
  </div>

  <div id="divFindSecretResult"></div>

  <div id="divFindSecretResult2"></div>

  <script type="text/javascript">
	$(document).ready(function () {
		$("input[type='button']").click(function (e) {
			if (e.target.id == "btnConstructSecret") {

				var q = parseInt($('#txtQ').val());
				var K = parseInt($('#txtK').val());
				var N = parseInt($('#txtN').val());
				var secret = parseInt($('#txtSecret').val());

				var degreeOfPolynomial = K - 1;
				var polynomArray = [];
				for (var i = 0; i < degreeOfPolynomial; i++)
					polynomArray.push(parseInt(Math.random() * q));
				polynomArray.push(secret);
				while (polynomArray[0] == 0)
					polynomArray[0] = parseInt(Math.random() * q);
				var polynom = new Polynomial(polynomArray, q);

				var polynomText = "f(" + polynom.Symbol + ")=";
				polynomText += polynom.Text;
				AddFormula("divConstSecretResult", "MathOutput1", polynomText);

				var shareText = "";
				for (var i = 1; i <= N; i++)
					shareText += "f(" + i + ")=" + polynom.Calculate(i) + "\\\\";

				AddFormula("divConstSecretResult", "MathOutput2", shareText);

				$('#txtQ2').val(q);
				$("#divSecretInputs").html(CreateInput(N, q));

				$("#divFindSecretResult").html("");
				$("#divFindSecretResult2").html("");
			}
			else if (e.target.id == "btnFindSecret") {
				var q = parseInt($('#txtQ2').val());
				var generator = new MatrixGenerator(q);
				var processor = new MatrixCalculator(q);

				$("#divFindSecretResult").html("");
				$("#divFindSecretResult2").html("");

				var pairs = [];
				$("[id^=txtInpt]").each(function() {
					if (!isNaN(parseInt($(this).val())))
						pairs.push([parseInt($(this).attr('num')), parseInt($(this).val())]);
				});

				$("#divFindSecretResult").append("<h4>Birinci Yöntem</h4>");
				var text1 = "L(x)=\\sum_{j=0}^{k}{y_jl_j(x)} \\\\ ";
				text1 += "l_j(x)=\\prod_{0 \\leq m \\leq k \\\\ m \\neq j}{\\frac{x-x_m}{x_j-x_m}}";

				AddFormula("divFindSecretResult", "MathOutput3", text1);
				L = [];
				var text = "", text2 = "", text3 = "";
				for (var k = 0; k < pairs.length; k++){
					text += "l_" + k + "(x)=";
					text2 = "";
					text3 = "";
					var polynom = new Polynomial(1, q);
					for (var i = 0; i < pairs.length; i++) {
						if (k == i) continue;
						var xk = pairs[k][0];
						var xi = pairs[i][0];
						var divider = xk - xi;
						var p = new Polynomial([1, -1 * xi], q).Divide(divider);

						text += "\\frac{(x-" + xi + ")}{(" + xk + "-" + xi + ")}";
						text2 += "[(x-" + xi + ")" + p.Degree.Inverse(divider) + "]";
						text3 += "(" + p.Text + ")";
						polynom = polynom.Multiply(p);
					}
					text += "\\\\ \\qquad=" + text2;
					text += "\\\\ \\qquad=" + text3;
					text += "\\\\ \\qquad=" + polynom.Text + "\\\\ \\qquad \\\\";
					L.push(polynom);
				}
				AddFormula("divFindSecretResult", "MathOutput4", text);

				var result = new Polynomial(0, q);
				var text = "L(x)=";
				var text2 = "L(x)=";
				for (var i = 0; i < L.length; i++) {
					result = result.Add(L[i].Multiply(pairs[i][1]));
					var tab = "";
					if (i != 0)
						tab = "\\qquad\\qquad+";
					text += tab + pairs[i][1] + "(" + L[i].Text + ")\\\\";
					text2 += tab + "(" + L[i].Multiply(pairs[i][1]).Text + ")\\\\";
				}
				var text3 = "L(x)=" + result.Text;
				AddFormula("divFindSecretResult", "MathOutput5", text);
				AddFormula("divFindSecretResult", "MathOutput6", text2);
				AddFormula("divFindSecretResult", "MathOutput7", text3);

				var secret = "Sır = " + result.Calculate(0);
				AddFormula("divFindSecretResult", "MathOutput8", secret);

				var indices = [];
				var values = [];
				for (var i = 0; i < pairs.length; i++){
					indices.push(pairs[i][0]);
					values.push(pairs[i][1]);
				}
				var Mw = generator.Vandermonde(pairs.length, indices);
				var Y = new Matrix(values).Transpose();
				var X = processor.Solve(Mw, Y);
				var det = processor.Determinant(Mw);
				var el = processor.Eliminate(Mw, Y);
				var textX = new MatrixGenerator().Pattern(pairs.length, 1, function(i,j) { return "x_{" + i + "}"; }).ToLatex();
				var textResult = Mw.ToLatex() + textX + "=" + Y.ToLatex();
				$("#divFindSecretResult2").append("<h4>İkinci Yöntem</h4>");
				AddFormula("divFindSecretResult2", "divMat_Result1", textResult);
				var textResult = "X=" + X.ToLatex();
				AddFormula("divFindSecretResult2", "divMat_Result2", "Determinant= " + det);
				AddFormula("divFindSecretResult2", "divMat_Result5", el.ToLatex());
				AddFormula("divFindSecretResult2", "divMat_Result4", textResult);
				AddFormula("divFindSecretResult2", "divMat_Result3", "Sır= " + X.Get(0,0));
			}
		});
	});
  </script>
</body>

</html>
